import { renderless as renderless$2, api as api$2 } from "@xmweb-ui/vue-renderless/color-picker/vue";
import { defineComponent, setup as _setup, props, directive } from "@xmweb-ui/vue-common";
import { IconChevronDown } from "@xmweb-ui/vue-icon";
import { renderless, api } from "@xmweb-ui/vue-renderless/color-picker/color-select/vue";
import "@xmweb-ui/vue-theme/color-picker/index.css";
import { openBlock, createElementBlock, createElementVNode, normalizeStyle, resolveComponent, resolveDirective, withDirectives, createVNode, Transition, withCtx, withModifiers, createBlock, createCommentVNode, createTextVNode, toDisplayString } from "vue";
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it)
    return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it)
      o = it;
    var i = 0;
    return function() {
      if (i >= o.length)
        return { done: true };
      return { done: false, value: o[i++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

import { renderless as renderless$1, api as api$1 } from "@xmweb-ui/vue-renderless/color-picker/alpha-select/vue";
import Button from "@xmweb-ui/vue-button";
import ButtonGroup from "@xmweb-ui/vue-button-group";
import Input from "@xmweb-ui/vue-input";
import Clickoutside from "@xmweb-ui/vue-renderless/common/deps/clickoutside";
import "@xmweb-ui/vue-locale";
var _sfc_main$2 = defineComponent({
  emits: ["hue-update", "sv-update"],
  props: {
    color: {
      type: String
    },
    alpha: {
      type: Boolean
    }
  },
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var _hoisted_1$2 = {
  class: "xm-color-picker__wrapper__inner"
};
var _hoisted_2$1 = /* @__PURE__ */ createElementVNode(
  "div",
  {
    class: "white"
  },
  null,
  -1
  /* HOISTED */
);
var _hoisted_3 = /* @__PURE__ */ createElementVNode(
  "div",
  {
    class: "black"
  },
  null,
  -1
  /* HOISTED */
);
var _hoisted_4 = {
  class: "cursor",
  ref: "cursor"
};
var _hoisted_5 = {
  class: "xm-color-picker__wrapper__inner__hue-select",
  ref: "bar"
};
var _hoisted_6 = {
  ref: "thumb"
};
function _sfc_render$2(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$2, [createElementVNode(
    "div",
    {
      class: "xm-color-picker__wrapper__inner__color-select",
      ref: "wrapper",
      style: normalizeStyle({
        background: _ctx.state.background
      })
    },
    [_hoisted_2$1, _hoisted_3, createElementVNode(
      "div",
      _hoisted_4,
      null,
      512
      /* NEED_PATCH */
    )],
    4
    /* STYLE */
  ), createElementVNode(
    "div",
    _hoisted_5,
    [createElementVNode(
      "div",
      _hoisted_6,
      null,
      512
      /* NEED_PATCH */
    )],
    512
    /* NEED_PATCH */
  )]);
}
var colorSelect = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["render", _sfc_render$2]]);
var _sfc_main$1 = defineComponent({
  emits: ["alpha-update"],
  props: {
    color: {
      type: String
    }
  },
  setup: function setup2(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless: renderless$1,
      api: api$1
    });
  }
});
var _hoisted_1$1 = {
  class: "xm-color-picker__wrapper__alpha",
  ref: "alphaWrapper"
};
var _hoisted_2 = {
  class: "xm-color-picker__wrapper__alpha__thumb",
  style: {
    top: 0,
    left: 0
  },
  ref: "alphaThumb"
};
function _sfc_render$1(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock(
    "div",
    _hoisted_1$1,
    [createElementVNode(
      "div",
      {
        class: "xm-color-picker__wrapper__alpha__slider",
        style: normalizeStyle({
          background: _ctx.state.background
        }),
        ref: "slider"
      },
      null,
      4
      /* STYLE */
    ), createElementVNode(
      "div",
      _hoisted_2,
      null,
      512
      /* NEED_PATCH */
    )],
    512
    /* NEED_PATCH */
  );
}
var alphaSelect = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1]]);
var _sfc_main = defineComponent({
  emits: ["update:modelValue", "confirm", "cancel"],
  props: [].concat(props, ["modelValue", "visible", "alpha"]),
  components: {
    IconChevronDown: IconChevronDown(),
    ColorSelect: colorSelect,
    AlphaSelect: alphaSelect,
    XmButton: Button,
    XmButtonGroup: ButtonGroup,
    XmInput: Input
  },
  directives: directive({
    Clickoutside
  }),
  setup: function setup3(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless: renderless$2,
      api: api$2
    });
  }
});
var _hoisted_1 = {
  class: "xm-color-picker__wrapper__tools"
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _ctx$state$triggerBg;
  var _component_IconChevronDown = resolveComponent("IconChevronDown");
  var _component_color_select = resolveComponent("color-select");
  var _component_alpha_select = resolveComponent("alpha-select");
  var _component_xm_input = resolveComponent("xm-input");
  var _component_xm_button = resolveComponent("xm-button");
  var _component_xm_button_group = resolveComponent("xm-button-group");
  var _directive_clickoutside = resolveDirective("clickoutside");
  return withDirectives((openBlock(), createElementBlock("div", {
    class: "xm-color-picker__trigger",
    onClick: _cache[2] || (_cache[2] = function() {
      return _ctx.changeVisible(!_ctx.state.isShow);
    })
  }, [createElementVNode(
    "div",
    {
      class: "xm-color-picker__inner",
      style: normalizeStyle({
        background: (_ctx$state$triggerBg = _ctx.state.triggerBg) != null ? _ctx$state$triggerBg : ""
      })
    },
    [createVNode(_component_IconChevronDown)],
    4
    /* STYLE */
  ), createVNode(Transition, {
    name: "xm-zoom-in-top"
  }, {
    default: withCtx(function() {
      return [_ctx.state.isShow ? (openBlock(), createElementBlock("div", {
        key: 0,
        class: "xm-color-picker__wrapper",
        onClick: _cache[1] || (_cache[1] = withModifiers(function() {
        }, ["stop"]))
      }, [createVNode(_component_color_select, {
        onHueUpdate: _ctx.onHueUpdate,
        onSvUpdate: _ctx.onSVUpdate,
        color: _ctx.state.hex
      }, null, 8, ["onHueUpdate", "onSvUpdate", "color"]), _ctx.alpha ? (openBlock(), createBlock(_component_alpha_select, {
        key: 0,
        color: _ctx.state.res,
        onAlphaUpdate: _ctx.onAlphaUpdate
      }, null, 8, ["color", "onAlphaUpdate"])) : createCommentVNode("v-if", true), createElementVNode("div", _hoisted_1, [createVNode(_component_xm_input, {
        modelValue: _ctx.state.res,
        "onUpdate:modelValue": _cache[0] || (_cache[0] = function($event) {
          return _ctx.state.res = $event;
        })
      }, null, 8, ["modelValue"]), createVNode(_component_xm_button_group, null, {
        default: withCtx(function() {
          return [createVNode(_component_xm_button, {
            type: "text",
            onClick: _ctx.onCancel
          }, {
            default: withCtx(function() {
              return [createTextVNode(
                toDisplayString(_ctx.t("ui.colorPicker.cancel")),
                1
                /* TEXT */
              )];
            }),
            _: 1
            /* STABLE */
          }, 8, ["onClick"]), createVNode(_component_xm_button, {
            onClick: _ctx.onConfirm
          }, {
            default: withCtx(function() {
              return [createTextVNode(
                toDisplayString(_ctx.t("ui.colorPicker.confirm")),
                1
                /* TEXT */
              )];
            }),
            _: 1
            /* STABLE */
          }, 8, ["onClick"])];
        }),
        _: 1
        /* STABLE */
      })])])) : createCommentVNode("v-if", true)];
    }),
    _: 1
    /* STABLE */
  })])), [[_directive_clickoutside, _ctx.onCancel]]);
}
var pc = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  pc as default
};
